package com.sillycycle.bagleyd.util;

import java.awt.Dimension;

public class Dimension3D extends Dimension {
	private static final long serialVersionUID = 42L;
	public int depth;

	/**
	 * Creates an instance of <code>Dimension</code> whose width
	 * and height are the same as for the specified dimension.
	 *
	 * @param width
	 * @param height
	 * @param depth
	 */
	public Dimension3D(int width, int height, int depth) {
		super.width = width;
		super.height = height;
		this.depth = depth;
	}

	/**
	 * Creates an instance of <code>Dimension</code> with a width
	 * of zero, a height of zero, and a depth of zero.
	 */
	public Dimension3D() {
		super.width = 0;
		super.height = 0;
		this.depth = 0;
	}

	/**
	 * Checks whether two dimension objects have equal values.
	 * @return true if all dimensions equal.
	 */
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Dimension3D) {
			Dimension3D d = (Dimension3D) obj;
			return (width == d.width) && (height == d.height) &&
				(depth == d.depth);
		}
		return false;
	}

	/**
	 * Returns the hash code for this <code>Dimension4D</code>.
	 *
	 * @return a hash code for this <code>Dimension4D</code>
	 */
	@Override
	public int hashCode() {
		int sum = width + height + depth;
		return sum * (sum + 2)/3 + width;
	}
}
